% $Id: Trapezoid.oz,v 1.1 2011/10/30 03:00:00 leavens Exp $
declare
% Trapezoid: <fun {$ <fun {$ <Float}: Float> <Float> <Float>}: Float>
fun {Trapezoid F X Delta}
   % REQUIRES: Delta >= 0.0
   % ENSURES: result is the area of the trapezoid inside the points:
   %          (X, {F X}),   (X+Delta, {F X+Delta}),
   %          (X, 0.0), and (X+Delta, 0.0).
   local
      Y1 = {F X}
      Y2 = {F X + Delta}
      Min_Height = {Min Y1 Y2}
      Max_Height = {Max Y1 Y2}
   in
      if Y1 >= 0.0 orelse Y2 >= 0.0
      then 
         Delta * Min_Height  % area of base rectangle
         + 0.5 * Delta * (Max_Height - Min_Height) % area of top triangle
      else
         Delta * Max_Height % area of base rectangle below x axis
         + 0.5 * Delta * (Min_Height - Max_Height) % area of bottom triangle
      end
   end
end
